Index: /pykota/branches/1.26_fixes/pykota/storages/ldapstorage.py
===================================================================
--- /pykota/branches/1.26_fixes/pykota/storages/ldapstorage.py (revision 3184)
+++ /pykota/branches/1.26_fixes/pykota/storages/ldapstorage.py (revision 3522)
@@ -1428,16 +1410,16 @@
                 if k.startswith("pykota") :
                     del fields[k]
-                elif k.lower() == "objectclass" :    
+                elif k.lower() == "objectclass" :
                     todelete = []
                     for i in range(len(fields[k])) :
-                        if fields[k][i].startswith("pykota") : 
+                        if fields[k][i].startswith("pykota") :
                             todelete.append(i)
-                    todelete.sort()        
+                    todelete.sort()
                     todelete.reverse()
                     for i in todelete :
                         del fields[k][i]
             if fields.get("objectClass") or fields.get("objectclass") :
-                self.doModify(user.ident, fields, ignoreold=0)        
-            else :    
+                self.doModify(user.ident, fields, ignoreold=0)
+            else :
                 self.doDelete(user.ident)
         result = self.doSearch("(&(objectClass=pykotaAccountBalance)(pykotaUserName=%s))" % \
@@ -1447,6 +1429,6 @@
         for (ident, fields) in result :
             self.doDelete(ident)
-        
-    def deleteGroup(self, group) :    
+
+    def deleteGroup(self, group) :
         """Completely deletes a group from the Quota Storage."""
         gname = self.userCharsetToDatabase(group.Name)
@@ -1461,5 +1443,5 @@
         for (ident, fields) in result :
             self.doDelete(ident)
-        result = self.doSearch("objectClass=pykotaGroup", None, base=group.ident, scope=ldap.SCOPE_BASE)    
+        result = self.doSearch("objectClass=pykotaGroup", None, base=group.ident, scope=ldap.SCOPE_BASE)
         if result :
             fields = result[0][1]
@@ -1467,39 +1449,39 @@
                 if k.startswith("pykota") :
                     del fields[k]
-                elif k.lower() == "objectclass" :    
+                elif k.lower() == "objectclass" :
                     todelete = []
                     for i in range(len(fields[k])) :
-                        if fields[k][i].startswith("pykota") : 
+                        if fields[k][i].startswith("pykota") :
                             todelete.append(i)
-                    todelete.sort()        
+                    todelete.sort()
                     todelete.reverse()
                     for i in todelete :
                         del fields[k][i]
             if fields.get("objectClass") or fields.get("objectclass") :
-                self.doModify(group.ident, fields, ignoreold=0)        
-            else :    
+                self.doModify(group.ident, fields, ignoreold=0)
+            else :
                 self.doDelete(group.ident)
-                
+
     def deleteManyBillingCodes(self, billingcodes) :
         """Deletes many billing codes."""
         for bcode in billingcodes :
             bcode.delete()
-        
-    def deleteManyUsers(self, users) :        
+
+    def deleteManyUsers(self, users) :
         """Deletes many users."""
         for user in users :
             user.delete()
-            
-    def deleteManyGroups(self, groups) :        
+
+    def deleteManyGroups(self, groups) :
         """Deletes many groups."""
         for group in groups :
             group.delete()
-        
-    def deleteManyPrinters(self, printers) :        
+
+    def deleteManyPrinters(self, printers) :
         """Deletes many printers."""
         for printer in printers :
             printer.delete()
-        
-    def deleteManyUserPQuotas(self, printers, users) :        
+
+    def deleteManyUserPQuotas(self, printers, users) :
         """Deletes many user print quota entries."""
         # TODO : grab all with a single (possibly VERY huge) filter if possible (might depend on the LDAP server !)
@@ -1509,5 +1491,5 @@
                 if upq.Exists :
                     upq.delete()
-            
+
     def deleteManyGroupPQuotas(self, printers, groups) :
         """Deletes many group print quota entries."""
@@ -1518,6 +1500,6 @@
                 if gpq.Exists :
                     gpq.delete()
-                
-    def deleteUserPQuota(self, upquota) :    
+
+    def deleteUserPQuota(self, upquota) :
         """Completely deletes an user print quota entry from the database."""
         uname = self.userCharsetToDatabase(upquota.User.Name)
@@ -1531,10 +1513,10 @@
             self.doDelete(upquota.Printer.LastJob.lastjobident)
         self.doDelete(upquota.ident)
-        
-    def deleteGroupPQuota(self, gpquota) :    
+
+    def deleteGroupPQuota(self, gpquota) :
         """Completely deletes a group print quota entry from the database."""
         self.doDelete(gpquota.ident)
-                
-    def deletePrinter(self, printer) :    
+
+    def deletePrinter(self, printer) :
         """Completely deletes a printer from the Quota Storage."""
         pname = self.userCharsetToDatabase(printer.Name)
@@ -1559,28 +1541,28 @@
         for (ident, fields) in result :
             self.doDelete(ident)
-        for parent in self.getParentPrinters(printer) :  
+        for parent in self.getParentPrinters(printer) :
             try :
                 parent.uniqueMember.remove(printer.ident)
-            except ValueError :    
+            except ValueError :
                 pass
-            else :    
+            else :
                 fields = {
                            "uniqueMember" : parent.uniqueMember,
-                         }  
-                self.doModify(parent.ident, fields)         
-        self.doDelete(printer.ident)    
-        
+                         }
+                self.doModify(parent.ident, fields)
+        self.doDelete(printer.ident)
+
     def deleteBillingCode(self, code) :
         """Deletes a billing code from the Quota Storage (no entries are deleted from the history)"""
         self.doDelete(code.ident)
-        
-    def sortRecords(self, fields, records, default, ordering) :     
+
+    def sortRecords(self, fields, records, default, ordering) :
         """Sort records based on list of fields prefixed with '+' (ASC) or '-' (DESC)."""
         fieldindexes = {}
         for i in range(len(fields)) :
             fieldindexes[fields[i]] = i
-        if not ordering :    
+        if not ordering :
             ordering = default
-        orderby = []    
+        orderby = []
         for orderkey in ordering :
             # Create ordering hints, ignoring unknown fields
@@ -1593,10 +1575,10 @@
                 if index is not None :
                     orderby.append((+1, index))
-            else :    
+            else :
                 index = fieldindexes.get(orderkey)
                 if index is not None :
                     orderby.append((+1, index))
-                
-        def compare(x, y, orderby=orderby) :    
+
+        def compare(x, y, orderby=orderby) :
             """Compares two records."""
             i = 0
@@ -1607,11 +1589,11 @@
                 if not result :
                     i += 1
-                else :    
+                else :
                     return sign * result
-            return 0 # identical keys        
-            
+            return 0 # identical keys
+
         records.sort(compare)
         return records
-        
+
     def extractPrinters(self, extractonly={}, ordering=[]) :
         """Extracts all printer records."""
@@ -1624,9 +1606,9 @@
                 if entry.PassThrough in (1, "1", "t", "true", "T", "TRUE", "True") :
                     passthrough = "t"
-                else :    
+                else :
                     passthrough = "f"
                 result.append((entry.ident, entry.Name, entry.PricePerPage, entry.PricePerJob, entry.Description, entry.MaxJobSize, passthrough))
-            return [fields] + self.sortRecords(fields, result, ["+dn"], ordering) 
-        
+            return [fields] + self.sortRecords(fields, result, ["+dn"], ordering)
+
     def extractUsers(self, extractonly={}, ordering=[]) :
         """Extracts all user records."""
@@ -1639,5 +1621,5 @@
                 result.append((entry.ident, entry.Name, entry.AccountBalance, entry.LifeTimePaid, entry.LimitBy, entry.Email, entry.Description, entry.OverCharge))
             return [fields] + self.sortRecords(fields, result, ["+dn"], ordering)
-        
+
     def extractBillingcodes(self, extractonly={}, ordering=[]) :
         """Extracts all billing codes records."""
@@ -1650,5 +1632,5 @@
                 result.append((entry.ident, entry.BillingCode, entry.Balance, entry.PageCounter, entry.Description))
             return [fields] + self.sortRecords(fields, result, ["+dn"], ordering)
-        
+
     def extractGroups(self, extractonly={}, ordering=[]) :
         """Extracts all group records."""
@@ -1661,5 +1643,5 @@
                 result.append((entry.ident, entry.Name, entry.LimitBy, entry.AccountBalance, entry.LifeTimePaid, entry.Description))
             return [fields] + self.sortRecords(fields, result, ["+dn"], ordering)
-        
+
     def extractPayments(self, extractonly={}, ordering=[]) :
         """Extracts all payment records."""
@@ -1680,5 +1662,5 @@
                         result.append((entry.Name, amount, date, description))
             return [fields] + self.sortRecords(fields, result, ["+date"], ordering)
-        
+
     def extractUpquotas(self, extractonly={}, ordering=[]) :
         """Extracts all userpquota records."""
@@ -1693,5 +1675,5 @@
                     result.append((user.Name, entry.Name, userpquota.ident, user.ident, entry.ident, userpquota.LifePageCounter, userpquota.PageCounter, userpquota.SoftLimit, userpquota.HardLimit, userpquota.DateLimit))
             return [fields] + self.sortRecords(fields, result, ["+userdn"], ordering)
-        
+
     def extractGpquotas(self, extractonly={}, ordering=[]) :
         """Extracts all grouppquota records."""
@@ -1706,5 +1688,5 @@
                     result.append((group.Name, entry.Name, grouppquota.ident, group.ident, entry.ident, grouppquota.LifePageCounter, grouppquota.PageCounter, grouppquota.SoftLimit, grouppquota.HardLimit, grouppquota.DateLimit))
             return [fields] + self.sortRecords(fields, result, ["+groupdn"], ordering)
-        
+
     def extractUmembers(self, extractonly={}, ordering=[]) :
         """Extracts all user groups members."""
@@ -1720,5 +1702,5 @@
                         result.append((entry.Name, member.Name, entry.ident, member.ident))
             return [fields] + self.sortRecords(fields, result, ["+groupdn", "+userdn"], ordering)
-                
+
     def extractPmembers(self, extractonly={}, ordering=[]) :
         """Extracts all printer groups members."""
@@ -1734,5 +1716,5 @@
                         result.append((parent.Name, entry.Name, parent.ident, entry.ident))
             return [fields] + self.sortRecords(fields, result, ["+pgroupdn", "+printerdn"], ordering)
-        
+
     def extractHistory(self, extractonly={}, ordering=[]) :
         """Extracts all jobhistory records."""
@@ -1740,10 +1722,10 @@
         if uname :
             user = self.getUser(uname)
-        else :    
+        else :
             user = None
         pname = extractonly.get("printername")
         if pname :
             printer = self.getPrinter(pname)
-        else :    
+        else :
             printer = None
         startdate = extractonly.get("start")
@@ -1755,7 +1737,7 @@
             result = []
             for entry in entries :
-                result.append((entry.UserName, entry.PrinterName, entry.ident, entry.JobId, entry.PrinterPageCounter, entry.JobSize, entry.JobAction, entry.JobDate, entry.JobFileName, entry.JobTitle, entry.JobCopies, entry.JobOptions, entry.JobPrice, entry.JobHostName, entry.JobSizeBytes, entry.JobMD5Sum, entry.JobPages, entry.JobBillingCode, entry.PrecomputedJobSize, entry.PrecomputedJobPrice)) 
+                result.append((entry.UserName, entry.PrinterName, entry.ident, entry.JobId, entry.PrinterPageCounter, entry.JobSize, entry.JobAction, entry.JobDate, entry.JobFileName, entry.JobTitle, entry.JobCopies, entry.JobOptions, entry.JobPrice, entry.JobHostName, entry.JobSizeBytes, entry.JobMD5Sum, entry.JobPages, entry.JobBillingCode, entry.PrecomputedJobSize, entry.PrecomputedJobPrice))
             return [fields] + self.sortRecords(fields, result, ["+dn"], ordering)
-            
+
     def getBillingCodeFromBackend(self, label) :
         """Extracts billing code information given its label : returns first matching billing code."""
@@ -1772,8 +1754,8 @@
             code.PageCounter = int(fields.get("pykotaPageCounter", [0])[0])
             code.Balance = float(fields.get("pykotaBalance", [0.0])[0])
-            code.Description = self.databaseToUserCharset(fields.get("description", [""])[0]) 
+            code.Description = self.databaseToUserCharset(fields.get("description", [""])[0])
             code.Exists = True
-        return code    
-        
+        return code
+
     def addBillingCode(self, bcode) :
         """Adds a billing code to the quota storage, returns it."""
@@ -1788,19 +1770,19 @@
                    "pykotaPageCounter" : str(bcode.PageCounter or 0),
                    "pykotaBalance" : str(bcode.Balance or 0.0),
-                   "description" : self.userCharsetToDatabase(bcode.Description or ""), 
-                 } 
+                   "description" : self.userCharsetToDatabase(bcode.Description or ""),
+                 }
         self.doAdd(dn, fields)
         bcode.isDirty = False
         return None # the entry created doesn't need further modification
-        
+
     def saveBillingCode(self, bcode) :
         """Sets the new description for a billing code."""
         fields = {
-                   "description" : self.userCharsetToDatabase(bcode.Description or ""), 
+                   "description" : self.userCharsetToDatabase(bcode.Description or ""),
                    "pykotaPageCounter" : str(bcode.PageCounter or 0),
                    "pykotaBalance" : str(bcode.Balance or 0.0),
                  }
         self.doModify(bcode.ident, fields)
-            
+
     def getMatchingBillingCodes(self, billingcodepattern) :
         """Returns the list of all billing codes which match a certain pattern."""
@@ -1811,11 +1793,5 @@
         if result :
             patterns = billingcodepattern.split(",")
-            try :
-                patdict = {}.fromkeys(patterns)
-            except AttributeError :    
-                # Python v2.2 or earlier
-                patdict = {}
-                for p in patterns :
-                    patdict[p] = None
+            patdict = {}.fromkeys(patterns)
             for (codeid, fields) in result :
                 codename = self.databaseToUserCharset(fields.get("pykotaBillingCode", [""])[0])
@@ -1825,10 +1801,10 @@
                     code.PageCounter = int(fields.get("pykotaPageCounter", [0])[0])
                     code.Balance = float(fields.get("pykotaBalance", [0.0])[0])
-                    code.Description = self.databaseToUserCharset(fields.get("description", [""])[0]) 
+                    code.Description = self.databaseToUserCharset(fields.get("description", [""])[0])
                     code.Exists = True
                     codes.append(code)
                     self.cacheEntry("BILLINGCODES", code.BillingCode, code)
-        return codes        
-        
+        return codes
+
     def consumeBillingCode(self, bcode, pagecounter, balance) :
         """Consumes from a billing code."""
@@ -1837,14 +1813,14 @@
                    "pykotaPageCounter" : { "operator" : "+", "value" : pagecounter, "convert" : int },
                  }
-        return self.doModify(bcode.ident, fields)         
-
-    def refundJob(self, jobident) :   
+        return self.doModify(bcode.ident, fields)
+
+    def refundJob(self, jobident) :
         """Marks a job as refunded in the history."""
         dn = "cn=%s,%s" % (ident, self.info["jobbase"])
         fields = {
                      "pykotaAction" : "REFUND",
-                 }    
-        self.doModify(dn, fields)         
-        
+                 }
+        self.doModify(dn, fields)
+
     def storageUserFromRecord(self, username, record) :
         """Returns a StorageUser instance from a database record."""
@@ -1852,5 +1828,5 @@
         user.Exists = True
         return user
-        
+
     def storageGroupFromRecord(self, groupname, record) :
         """Returns a StorageGroup instance from a database record."""
@@ -1858,5 +1834,5 @@
         group.Exists = True
         return group
-        
+
     def storagePrinterFromRecord(self, printername, record) :
         """Returns a StoragePrinter instance from a database record."""
@@ -1864,9 +1840,9 @@
         printer.Exists = True
         return printer
-        
-    def setJobAttributesFromRecord(self, job, record) :    
+
+    def setJobAttributesFromRecord(self, job, record) :
         """Sets the attributes of a job from a database record."""
         job.Exists = True
-        
+
     def storageJobFromRecord(self, record) :
         """Returns a StorageJob instance from a database record."""
@@ -1874,5 +1850,5 @@
         self.setJobAttributesFromRecord(job, record)
         return job
-        
+
     def storageLastJobFromRecord(self, printer, record) :
         """Returns a StorageLastJob instance from a database record."""
@@ -1880,5 +1856,5 @@
         self.setJobAttributesFromRecord(lastjob, record)
         return lastjob
-        
+
     def storageUserPQuotaFromRecord(self, user, printer, record) :
         """Returns a StorageUserPQuota instance from a database record."""
@@ -1886,5 +1862,5 @@
         userpquota.Exists = True
         return userpquota
-        
+
     def storageGroupPQuotaFromRecord(self, group, printer, record) :
         """Returns a StorageGroupPQuota instance from a database record."""
@@ -1892,5 +1868,5 @@
         grouppquota.Exists = True
         return grouppquota
-        
+
     def storageBillingCodeFromRecord(self, billingcode, record) :
         """Returns a StorageBillingCode instance from a database record."""
